/*
 * JBoss, Home of Professional Open Source.
 * Copyright 2010, Red Hat Middleware LLC, and individual contributors
 * as indicated by the @author tags. See the copyright.txt file in the
 * distribution for a full listing of individual contributors.
 *
 * This is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation; either version 2.1 of
 * the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this software; if not, write to the Free
 * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA, or see the FSF site: http://www.fsf.org.
 */
package org.jboss.test.ws.jaxws.jbws3022.service;

import javax.jws.WebService;
import javax.jws.WebMethod;
import javax.jws.WebParam;
import javax.jws.HandlerChain;
import javax.xml.ws.Action;
import javax.xml.ws.soap.Addressing;
import javax.xml.ws.soap.AddressingFeature;

@WebService(name = "AddNumbersPortType3", portName = "AddNumbersPort3", serviceName = "AddNumbersService3", targetNamespace = "http://example.com/")
@Addressing(enabled = true, required = true, responses = AddressingFeature.Responses.ANONYMOUS)
@HandlerChain(name = "", file = "server-handler.xml")
public class AddNumbersImpl3
{
   @Action(input = "http://example.com/AddNumbersPortType3/add", output = "http://example.com/AddNumbersPortType3/addResponse")
   @WebMethod
   public int addNumbers(@WebParam(name = "number1", targetNamespace = "http://example.com/") int number1,
         @WebParam(name = "number2", targetNamespace = "http://example.com/") int number2,
         @WebParam(name = "testName", targetNamespace = "http://example.com/") String testName)
         throws AddNumbersException
   {

      if (number1 < 0 || number2 < 0)
      {
         throw new AddNumbersException("Negative numbers can't be added!", "Numbers: " + number1 + ", " + number2);
      }
      return number1 + number2;
   }
}
